/*
 * Copyright (C) 2002 Luca Abeni
 * This is Free Software; see GPL.txt for details
 */

#ifndef __TIME_H__
#define __TIME_H__

#include <linux/module.h>
#ifndef CONFIG_GENERIC_SCHEDULER
#error The Generic Scheduler is not enabled!!!
#endif

static inline unsigned long long int sched_read_clock(void)
{
  unsigned long long int ts;
  struct timeval tv;

  do_gettimeofday(&tv);
  ts = (unsigned long long int)tv.tv_usec + (unsigned long long int)tv.tv_sec * 1000000LLU;

  return ts;
}

/* static inline unsigned long long int llimd(unsigned long long ull, unsigned long mult, unsigned long div); */

/* fast_gettimeoffset_quotient = 2^32 * (1 / (TSC clocks per usec)) */
static inline unsigned long long int us2clock(unsigned long u)
{
  return u;
}

static inline unsigned long int clock2ms(unsigned long long int c)
{
  unsigned long int ms;
  ms = llimd(c, 1, 1000);
  return ms;
}

static inline unsigned long long int clock2us(unsigned long long c)
{
  return c;
}

static inline unsigned long int clock2jiffies(unsigned long long c)
{
  return llimd(c, HZ, 1000000);
}

#endif /* __TIME_H__ */
