/*
 * Copyright (C) 2002 Luca Abeni
 * This is Free Software; see GPL.txt for details
 */

#ifndef __LOG_H__
#define __LOG_H__

#ifdef __LOGGER__
#include <logger.h>
#define sched_print(args...) log_printf(0, ## args)
#define sched_warning(args...) log_printf(0, ## args)
#define sched_error(args...) log_printf(0, ## args)
#else
#define sched_print printk
#define sched_warning printk
#define sched_error printk
#endif

#ifdef __CBS_DEBUG__
#define cbs_dbg sched_print
#else
#define cbs_dbg(...)
#endif
#ifdef __GRUB_DEBUG__
#define grub_dbg sched_print
#else
#define grub_dbg(...)
#endif
#ifdef __EXTRA_WARNINGS__
#define sched_extra_warning sched_warning
#else
#define sched_extra_warning(...)
#endif

#endif	/* __LOG_H__ */
