#ifndef __MULDIV_H__
#define __MULDIV_H__

/* This comes from RTAI... Please, adjust the license stuff!!! */

static inline unsigned long long ullmul(unsigned long m0, unsigned long m1)
{
  unsigned long long res;

  __asm__ __volatile__ ("mulhwu %0, %1, %2" : "=r" (((unsigned long *)&res)[0]) : "%r" (m0), "r" (m1));
  ((unsigned long *)&res)[1] = m0 * m1;

  return res;
}

static inline unsigned long long ulldiv(unsigned long long ull, unsigned long uld, unsigned long *r)
{
	unsigned long long q, rf;
	unsigned long qh, rh, ql, qf;

	q = 0;
	rf = (unsigned long long)(0xFFFFFFFF - (qf = 0xFFFFFFFF / uld) * uld) + 1ULL;

	while (ull >= uld) {
		((unsigned long *)&q)[0] += (qh = ((unsigned long *)&ull)[0] / uld);
		rh = ((unsigned long *)&ull)[0] - qh * uld;
		q += rh * (unsigned long long)qf + (ql = ((unsigned long *)&ull)[1] / uld);
		ull = rh * rf + (((unsigned long *)&ull)[1] - ql * uld);
	}

	*r = ull;
	return q;
}

// returns (long long)ll = (int)ll*(int)(mult)/(int)div.
static inline unsigned long long llimd(unsigned long long ull, unsigned long mult, unsigned long div)
{
  unsigned long long low;
  unsigned long q, r;

  low = ullmul(((unsigned long *)&ull)[1], mult);
  q = ulldiv(ullmul(((unsigned long *)&ull)[0], mult) + ((unsigned long *)&low)[0], div, (unsigned long *)&low);
  low = ulldiv(low, div, &r);
  ((unsigned long *)&low)[0] += q;

  return (r + r) > div ? low + 1 : low;
}
#endif	/* __MULDIV_H__ */
