/*
 * Copyright (C) 2002 Luca Abeni
 * This is Free Software; see GPL.txt for details
 */

#ifndef __TIMERS_H__
#define __TIMERS_H__

#include <linux/module.h>
#ifndef CONFIG_GENERIC_SCHEDULER
#error The Generic Scheduler is not enabled!!!
#endif

struct t_data_struct {
  struct timer_list timer;
  void (* callback)(unsigned long long int time, void *param);
  void *param;
  unsigned long long int start_time;
  unsigned long long int requested_interval;
  int armed;
#ifdef __TIMERS_CHECK__
  int id;
#endif
};

void sched_stop_timer(struct t_data_struct *Sched);
void sched_set_timer(unsigned long long int t, struct t_data_struct *tdata);
void sched_init_timer(struct t_data_struct *tdata);

#endif /* __TIMERS_H__ */
