/*
 * Copyright (C) 2002 Luca Abeni
 * This is Free Software; see GPL.txt for details
 */

#ifndef __TRACE_H__
#define __TRACE_H__

#ifdef __CBS_TRACE__
void trc_dispatch(int pid, unsigned long long int time);
void trc_activation(int pid, unsigned long long int time);
void trc_deactivation(int pid, unsigned long long int time);
void trc_creation(int pid, unsigned long long int time);
void trc_destruction(int pid, unsigned long long int time);
void trc_start(unsigned long long int time);
void trc_dl_assign(int pid, unsigned long long int time,
		unsigned long long int new_dl);
void trc_dl_postpone(int pid, unsigned long long int time,
		unsigned long long int old_dl, unsigned long long int new_dl);
#define trace_dispatch(t, time) trc_dispatch(srv_id(t), time)
#define trace_idle_dispatch(time) trc_dispatch(0, time)
#define trace_activation(t, time) trc_activation(srv_id(t), time)
#define trace_deactivation(t, time) trc_deactivation(srv_id(t), time)
#define trace_creation(t, time) trc_creation(srv_id(t), time)
#define trace_destruction(t, time) trc_destruction(srv_id(t), time)
#define trace_start(time) trc_start(time)
#define trace_dl_assign(t, time, new_dl) trc_dl_assign(srv_id(t), time, new_dl)
#define trace_dl_postpone(t, time, old_dl, new_dl) trc_dl_postpone(srv_id(t), time, old_dl, new_dl)
#else
#define trace_dispatch(t, time)
#define trace_idle_dispatch(time)
#define trace_activation(t, time)
#define trace_deactivation(t, time)
#define trace_creation(t, time)
#define trace_destruction(t, time)
#define trace_start(time)
#define trace_dl_assign(t, time, new_dl)
#define trace_dl_postpone(t, time, old_dl, new_dl)
#endif
#endif
